#!/usr/bin/perl -w

# load the CGI routines in our Perl script
use strict;
use Apache::Registry;
use CGI;
use DBI;
#

my ($dbh,$sth,$rc,$rv);
my $inhalt;

my $in = new CGI;

print $in->header;
print $in->start_html("Suche im Katalog");

$dbh = DBI->connect("DBI:mysql:buch") || &CgiDie("Konnte Datenbank nicht oeffnen");

my $ausgabe="K";
if($in->param('ausgabe')) { $ausgabe=$in->param('ausgabe'); }

my $string="";
if ($inhalt=$in->param('autor')) {
    $inhalt=$dbh->quote($inhalt."%");
    $string = "(id like '20_' and text like $inhalt)";
}
elsif ($inhalt=$in->param('titel')) {
    $inhalt=$dbh->quote("%".$inhalt."%");
    $string = "(id like '32_' and text like $inhalt)";
}
elsif ($inhalt=$in->param('ort')) {
    $inhalt=$dbh->quote($inhalt."%");
    $string = "(id='410' and text like $inhalt)";
}
elsif ($inhalt=$in->param('jahr')) {
    $inhalt=$dbh->quote($inhalt);
    $string = "(id='425' and text=$inhalt)";
}
elsif ($inhalt=$in->param('isbn')) {
    $inhalt=$dbh->quote($inhalt);
    $string = "(id='540' and text=$inhalt)";
}
elsif ($inhalt=$in->param('samm')) {
    $inhalt=$dbh->quote("%".$inhalt."%");
    $string = "(id='460' and text like $inhalt)";
}
elsif ($inhalt=$in->param('buch')) {
    $string = "(buchnr = $inhalt)";
}

if ($string) {
  my $zeit=time;
  $sth = $dbh->prepare(qq{select * from komplett where $string group by buchnr}) if ($string) || &CgiDie ("Leere Abfrage<BR>Bitte einen Parameter eingeben"); 
  $rv = $sth->execute     || die $sth->errstr;
  my $i=0;
  my @ary=();
  while (my $ref = $sth->fetchrow_arrayref) {
    $ary[$i++] = [ @{$ref} ];
    last if ($i==150);
  }
  $sth->finish;  
  
  my ($buchnr,$id,$text);

  print $in->h1("Suchergebniss");    
  print "Suchzeit: ".(time-$zeit)." sek. ; ";
  print "Anzahl der Treffer: ".@ary."<p>\n";
  print "<a href=\"komplett.cgi\">neue Suche</a><hr>";

  if($ausgabe=~/E/) {  # sql Ergebnis ausgeben
    print <<EOM;
<table><tr>
<td><b>Buch Nr.</b></td>
<td><b>Feld</b></td>
<td><b>Text</b></td>
</tr>
EOM

    foreach $i (@ary) {
      ($buchnr,$id,$text)=@{$i};
      print <<EOM;
<tr>
 <td><a href="komplett.cgi?buch=$buchnr">$buchnr</a>
 </td><td>$id</td>
 <td>$text</td>
</tr>
EOM
    }
    print "</table><hr>\n";
  } 
  foreach $i (@ary) {
    ($buchnr)=@{$i};
    $buchnr=$dbh->quote($buchnr);
    $sth = $dbh->prepare(qq{select id,text from komplett where 
			      buchnr=$buchnr});
    $rv = $sth->execute     || die $sth->errstr;
    my %buch=();
    while (my $ref = $sth->fetchrow_arrayref) {
      ($id,$text)=  @{$ref} ;
      $buch{$id}=$text;
    }
    if($ausgabe=~/A/) {  # Alles ausgeben
      foreach $i (keys %buch) {
	print "$i $buch{$i}<br>";
      }
    }
    if($ausgabe=~/K/) {  # Karteikarten ausgeben
      # Autor
      foreach $i (grep /^20/, keys %buch) { print "<i>$buch{$i}</i> ; "; }
      print "<br>\n";
      # Titel
      print "<b>$buch{'320'}</b> " if($buch{'320'});
      # Subtitel
      print ": $buch{'335'}" if ($buch{'335'});
      print "<br>\n"; 
      # Ort
      print "$buch{'410'} " if ($buch{'410'});
      # Verlag
      print ": $buch{'412'}" if ($buch{'412'});
      # Jahr
      print ", $buch{'425'}" if ($buch{'425'});
      print "<br>\n";
      # Titel Sammelwerk
      print "$buch{'460'}<br>\n" if ($buch{'460'});
      # ISBN
      print "ISBN $buch{'540'}<br>\n" if ($buch{'540'});
      # Standort
      print "<i>Standort: $buch{'071'}</i><br>\n" if ($buch{'071'});
      # AMS Klassifikation
      if ($buch{'150'}) {
	print "AMS-Klassifikation: ";
	foreach $i (grep /^15/, keys %buch) { print "$buch{$i} * "; }
	print "<br>\n";
      }
    }
    if($ausgabe=~/U/) {  # Kursform ausgeben
      # Autor
      foreach $i (grep /^20/, keys %buch) { print "<i>$buch{$i}</i> ; "; }
      # Titel
      print "<b>$buch{'320'}</b> " if($buch{'320'});
      # Jahr
      print ", $buch{'425'}" if ($buch{'425'});
      print "<br>\n";
      # Standort
      print "<i>Standort: $buch{'071'}</i><br>\n" if ($buch{'071'});
    }
    $sth->finish;  
    print "<hr>\n\n";
    }
}
else {
print <<EOM;
<HTML><HEAD><TITLE>Submit Logon</TITLE></HEAD>
<BODY><CENTER>
<H1>Katalog der Bibliothek des Mathematischen Institutes</h1><hr>

<FORM METHOD=GET ACTION="/cgi-bin/komplett.cgi">

<input type=submit value="Suche starten">
<INPUT TYPE=reset VALUE="Felder lschen"><br>
<b>Ausgabe als:</b>
<INPUT TYPE=radio NAME=ausgabe value="K"> Karteikarte
<INPUT TYPE=radio NAME=ausgabe value="U"> Kurzform 
<INPUT TYPE=radio NAME=ausgabe value="A"> komplette Liste
<INPUT TYPE=radio NAME=ausgabe value="E"> SQL Ergebnis 
<p>
<b>Achtung: z.Z. nur wird nur ein ausgeflltes Feld bercksichtigt</b><p>
<TABLE>
<TR><TH>Autor</TH><TD><INPUT TYPE=TEXT NAME=autor></td></tr>
<tr><th>Titel</th><td><INPUT TYPE=TEXT NAME=titel></td></tr>
<tr><th>Ort</th><td><INPUT TYPE=TEXT NAME=ort></td></tr>
<tr><th>Jahr</th><td><INPUT TYPE=TEXT NAME=jahr></td></tr>
<tr><th>ISBN</th><td><INPUT TYPE=TEXT NAME=isbn></td></tr>
<tr><th>Sammelwerk</th><td><INPUT TYPE=TEXT NAME=samm></td></tr>
</TABLE><p>
</center>
</form>
<HR>
</body>
</HTML>
EOM
}

$rc = $dbh->disconnect;
print $in->end_html();
